#ifndef DATA_H_INCLUDED
#define DATA_H_INCLUDED

#ifdef _LINUX
#include <stdint.h>

#ifndef max
	#define max( a, b ) ( ((a) > (b)) ? (a) : (b) )
#endif

#ifndef min
	#define min( a, b ) ( ((a) < (b)) ? (a) : (b) )
#endif


	static char* itoa(int value, char* result, int base) {
		// check that the base if valid
		if (base < 2 || base > 36) { *result = '\0'; return result; }
	
		char* ptr = result, *ptr1 = result, tmp_char;
		int tmp_value;
	
		do {
			tmp_value = value;
			value /= base;
			*ptr++ = "zyxwvutsrqponmlkjihgfedcba9876543210123456789abcdefghijklmnopqrstuvwxyz" [35 + (tmp_value - value * base)];
		} while ( value );
	
		// Apply negative sign
		if (tmp_value < 0) *ptr++ = '-';
		*ptr-- = '\0';
		while(ptr1 < ptr) {
			tmp_char = *ptr;
			*ptr--= *ptr1;
			*ptr1++ = tmp_char;
		}
		return result;
	}
	


#define _ui64toa itoa


#endif

extern const unsigned char bit_mask[8];
extern const unsigned char castle_mask[64];

extern const int b64to256[B2_SIZE];
extern const int b256to64[B_SIZE];

static int knight_mob[64];
static int bishop_mob[64];

extern uint64_t zobrist[2][8][64];
extern uint64_t zobrist_enp[64];
extern uint64_t zobrist_castle[16];
extern uint64_t zobrist_side;

extern const unsigned char table_attack[256];
extern const uint16_t i2b[16];
extern uint8_t b2n[256];

extern const int direction[256];

extern uint64_t bit_square[256];
extern uint64_t bit_ray[256][256];
extern uint64_t bit_scan[256][8];
extern uint64_t bit_file[256];
extern uint64_t bit_rank[256];
extern uint64_t bit_isolated[256];
extern uint64_t bit_backward[2][256];
extern uint64_t bit_passed[2][256];
extern uint64_t bit_weaksquare[2][256];

extern const int sq_color[64];

extern int piece_value[8];
extern const int piece_value2[8];
extern int value[64];

extern TREE tree;
extern ENGINE mizar;

extern EVAL_HASH* eval_hash;
extern unsigned eval_hash_mask;
extern TT_LIST* hash_table;
extern uint16_t attacked_by_low[2][16];
extern uint16_t attacked_by_hi[2][16];
extern uint16_t attacked_by_eq[2][16];
extern uint16_t pw_attack_pattern[2];




#endif          /* DATA_H_INCLUDED */
