/*--------------------------------------*/
/*                                      */
/* Mizar - Winboard Chess Engine        */
/*                                      */
/* 2006 (c) Nicola Rizzuti - Italy      */
/*                                      */
/*--------------------------------------*/

#include "mizar.h"

/*crea numeri casuali a 64 bit*/
uint64_t rand64() {
	return (rand() ^ ((uint64_t)rand() << 15) ^ ((uint64_t)rand() << 30) ^
	        ((uint64_t)rand() << 45) ^ ((uint64_t)rand() << 60));
	}

/*crea la chiave hash per la posizione*/
inline void set_hashkey() {
	char c, i;

	Hash = 0;

	for (i = 0;i < 2;i++)
		for (c = 0;c < 16;c++) {
				if (Active(i,c))
					Hash ^= zobrist[i][Name(i, c)][b256to64[Position(i, c)]];
				}

	if (Side)
		Hash ^= zobrist_side;

	UpdateHashCastle(Cstr);

	Hash ^= zobrist_enp[b256to64[Enp]];
	}
